
// *******************************************************
//;* Title:      
//;* Version		: 1.1 		  for ImageCraft 
//;* Last updated	: 06.03.2009
//;* Target		: AT90S2313
//;* Easily modified for	: Any AVR microcontroller
//;* Author: 	  ..   Email: mart.g@mail.ru
//********************************************************

#include <io2313v.h>
#include <macros.h>

//;***** Pin definitions
//;*******************************************************
#define IN_Port       PORTD	  //  
#define OUT_Port      PORTB	  //  
#define U_Tros       0	              // PD0 -  
#define   Tros       1	              // PD1 -  
#define U_Sens       (PIND & 0x04)	  // PD2 -  
#define MIDL         (PIND & 0x08)	  // PD3 - 
#define DOWN         (PIND & 0x10)	  // PD4 -  
#define ON           (PIND & 0x20)    // PD5 -  .  
#define OFF          (PIND & 0x40)	  // PD6 -  . 
#define ON_Nas       (OUT_Port &= ~ 0x04) // PB2 -   "0" 
#define OFF_Nas      (OUT_Port |=   0x04) // PB2 -  "1" 
#define LED_MIDL       0		  // PB0 -  ()
#define LED_DOWN       1	      // PB1 -   ()
//;*************************************************************

// 90S2313  ICC  <macros.h>   4 = 0,250S        							    
void delayN(unsigned char  n)	       //9,75 + n*1,0  
{	unsigned char a;
	for (a = 1; a<n; a++);   }
//************************  End of delay routines ****************   
  
//**************** MAIN *****************************
unsigned char eee;          // 	
unsigned char ON_OFF_flag;  // 1- on  0 - off - \ 
unsigned char DOWN_flag;    // 1- on  0 - off -   ("1")
main()                                       //    ()
  {	int i;
//Reset -     (. ) *********
    SPL = 0xDF;   //stack init for 2313   	  
	DDRB = 0x07;  //init portB "0"-, "1"- out              0b00000111=$07
	PORTB =0x07;  //"0"-Hi-Z "1"- out , if DDRB=0 ()  0b00000111=$07	   
	DDRD = 0x07;  //init portD "0"-, "1"- out (D5 - ON; D6-OFF)
	PORTD = 0x07; //"0"-Hi-Z ,"1"- out , if DDRB=0         0b00000111=$07	                                                            
	    //end Reset ******************************************
// Main
    ON_OFF_flag =0; 				  		  	  
	while ( 1 ) 	 			//  while  Main
		{ if (ON == 0)          //   . 
			  { delayN(100);    //9,75 + n*1,0 
	            if (ON == 0)  ON_OFF_flag=1;  	
	           }		 //end    if   ON     *********************			  		  
          if (OFF  == 0)        //   . 
			  {	delayN(100);            //9,75 + n*1,0 
	            if (OFF  == 0)  ON_OFF_flag=0;
	           }		 //end    if   OFF     ********************			  
	     IN_Port &= ~ (1<<U_Tros);	   //  U_Tros = 0
	     IN_Port &= ~ (1<< Tros);	   //  Tros = 0
		 IN_Port |=(1<< U_Sens);       //  U_Sens = 5V
		 			  
          if (MIDL == 0)                         //   
			  {	OUT_Port   &= ~(1<< LED_MIDL);        //  
			   }
			  else { OUT_Port  |=  (1<<LED_MIDL); }   //  			  
          if ( DOWN == 0)                   //    
			  {	 OUT_Port  |=  (1<<LED_DOWN);       //  
                  DOWN_flag =0; 			  
			   }
			  else { OUT_Port   &= ~  (1<<LED_DOWN);   //  		
			         DOWN_flag =1; 	               //   ()
			        } 	   			  
          if  (ON_OFF_flag )    
		           { if ( DOWN_flag)   //      ()	
                           {OFF_Nas;}				   
				      else {ON_Nas;}   //    
				   }         
		    else { OFF_Nas;}        //    		  
		} //  while  Main
	} 	 // end   
